<?php

namespace App\Services\Customer\Wallet;

use App\DTOs\Customer\Wallet\CouponDTO;
use App\Entities\CommonEntity;
use App\Entities\Customer\ClientEntity;
use App\Entities\Customer\Wallet\CouponEntity;
use App\Forms\Customer\Wallet\CouponForm;
use App\Helpers\Customer\Wallet\CouponHelper;
use App\Models\Customer\Wallet\CouponModel;
use RuntimeException;

class CouponService extends WalletService
{
    const CLIENTINFO_BALANCE_FIELD = 'coupon_balance';
    protected string $formClass = CouponForm::class;
    protected string $helperClass = CouponHelper::class;

    public function __construct(CouponModel $model)
    {
        parent::__construct($model);
        $this->addClassPaths('Coupon');
    }
    public function getDTOClass(): string
    {
        return CouponDTO::class;
    }
    public function createDTO(array $formDatas): CouponDTO
    {
        return new CouponDTO($formDatas);
    }
    public function getEntityClass(): string
    {
        return CouponEntity::class;
    }
    //기본 기능부분
    protected function getEntity_process(mixed $entity): CouponEntity
    {
        return $entity;
    }
    protected function modify_process($entity, array $formDatas): CommonEntity
    {
        throw new RuntimeException("쿠폰정보는 수정이 불가합니다.");
    }
    //List 검색용
    //FormFilter 조건절 처리
    //검색어조건절처리

    //입금,쿠폰 충전 처리
    protected function deposit_process(ClientEntity $clientEntity, array $formDatas): array
    {
        if (!array_key_exists('amount', $formDatas)) {
            throw new RuntimeException(static::class . '->' . __FUNCTION__ . "에서 오류발생: 쿠폰수가 정의되지 않았습니다.");
        }
        //최종처리
        $formDatas['balance'] = $clientEntity->getCouponBalance() + $formDatas['amount'];
        if ($formDatas['balance'] < 0) {
            throw new RuntimeException(static::class . '->' . __FUNCTION__ . "에서 오류발생:  쿠폰수가 0보다 작은 값이 정의 되었습니다.");
        }
        //고객 잔액 갱신
        service('customer_clientservice')->modify_process($clientEntity, [self::CLIENTINFO_BALANCE_FIELD => $formDatas['balance']]);
        return parent::deposit_process($clientEntity, $formDatas);
    }
    //결제 관련 쿠폰 사용 처리
    protected function withdrawal_process(ClientEntity $clientEntity, array $formDatas): array
    {
        if (!array_key_exists('amount', $formDatas)) {
            throw new RuntimeException(static::class . '->' . __FUNCTION__ . "에서 오류발생: 출금액이 정의되지 않았습니다.");
        }
        if ($clientEntity->getCouponBalance() < $formDatas['amount']) {
            throw new RuntimeException(sprintf(
                "%s 에서 오류발생: 사용쿠폰 수량(%s) , %s 잔여쿠폰 수량(%s)이 부족합니다.",
                static::class . '->' . __FUNCTION__,
                number_format($formDatas['amount']),
                $clientEntity->getTitle(),
                number_format($clientEntity->getCouponBalance())
            ));
        }
        //최종처리
        $formDatas['balance'] = $clientEntity->getCouponBalance() - $formDatas['amount'];
        if ($formDatas['balance'] < 0) {
            throw new RuntimeException(static::class . '->' . __FUNCTION__ . "에서 오류발생: 잔여쿠폰수량({$formDatas['balance']})이 0보다 작은 값이 정의되었습니다.");
        }
        //고객 잔여쿠폰 갱신
        service('customer_clientservice')->modify_process($clientEntity, [self::CLIENTINFO_BALANCE_FIELD => $formDatas['balance']]);
        return parent::withdrawal_process($clientEntity, $formDatas);
    }
}
